import { Router } from 'vue-router';
import { RoutiderLocation, RoutiderLocationOfNames } from './route/location';
import { RoutiderOptions, RouteNames } from './options/options';
import { RoutiderRouter, RoutiderRouteLocation } from './router/router';
import { RoutiderNavigationGuard } from './router/navigationGuard';
declare const validTypeLocation: unique symbol;
export declare type ValidTypeLocation = typeof validTypeLocation;
export interface Routider<O extends RoutiderOptions> {
    rawRouter: Router;
    router: RoutiderRouter<O>;
    useRouter: () => RoutiderRouter<O>;
    useRoute: <N extends RouteNames<O['routes']> | RouteNames<O['routes']>[] | null>(name: N) => N extends null ? RoutiderLocation<undefined, string, string, RouteNames<O['routes']>> : RoutiderLocationOfNames<O['routes'], Exclude<N, null>>;
    onBeforeRouteLeave: (leaveGuard: RoutiderNavigationGuard<O['routes']>) => void;
    onBeforeRouteUpdate: (updateGuard: RoutiderNavigationGuard<O['routes']>) => void;
    ensureLocationType<N extends RouteNames<O['routes']>>(location: RoutiderRouteLocation<O['routes'], N>): RoutiderRouteLocation<O['routes'], N> & ValidTypeLocation;
}
export declare const createRoutider: <O extends RoutiderOptions>(options: O) => Routider<O>;
export {};
