import { RouteLocationNormalizedLoaded, RouteLocationNormalized } from 'vue-router';
import { RouteNames, RoutiderRoutes } from '../options/options';
import { ExtractParams } from '../options/path';
import { RouteRecordName } from '../options/name';
import { RoutiderRouteRecord } from './route';
import { EntityOrArrayToUnion, UnionToIntersection } from '../type';
import { ExtractQueries, QueryMap } from '../options/queries';
declare type RecordWithOptional<KRequired extends string | number | symbol, KOptional extends string | number | symbol, V> = Record<KRequired, V> & Partial<Record<KOptional, V>>;
export interface Params<ParamNames extends string | undefined, OptionalParamNames extends string | undefined> {
    params: Readonly<RecordWithOptional<Exclude<ParamNames, undefined>, Exclude<OptionalParamNames, undefined>, string | string[]>>;
}
export interface Queries<Names extends string | undefined> {
    query: Readonly<QueryMap<Exclude<Names, undefined>>>;
}
/**
 * Typed `RouteLocationNormalized`
 */
export declare type RoutiderLocationN<ParamNames extends string | undefined, OptionalParamNames extends string | undefined, QueryNames extends string | undefined, RouteName extends RouteNames<RoutiderRoutes>> = Omit<RouteLocationNormalized, 'params' | 'query'> & {
    name: RouteName;
} & Params<ParamNames, OptionalParamNames> & Queries<QueryNames>;
/**
 * Typed `RouteLocationNormalizedLoaded`
 */
export declare type RoutiderLocation<ParamNames extends string | undefined, OptionalParamNames extends string | undefined, QueryNames extends string | undefined, RouteName extends RouteNames<RoutiderRoutes>> = Omit<RouteLocationNormalizedLoaded, 'params' | 'query'> & {
    name: RouteName;
} & Params<ParamNames, OptionalParamNames> & Queries<QueryNames>;
declare type RoutesOfNames<Routes extends RoutiderRoutes, Ns extends RouteNames<Routes> | RouteNames<Routes>[]> = {
    [N in EntityOrArrayToUnion<Ns>]: Routes[N];
};
declare type IntersectionParamsOfRoutes<Rs extends Record<RouteRecordName, RoutiderRouteRecord>> = ExtractParams<UnionToIntersection<{
    [K in keyof Rs]: Exclude<Rs[K]['path'], string | string[]>;
}[keyof Rs]>>;
declare type UnionParamsOfRoutes<Rs extends Record<RouteRecordName, RoutiderRouteRecord>> = {
    [K in keyof Rs]: ExtractParams<Rs[K]['path']>;
}[keyof Rs];
declare type UnionQueriesOfRoutes<Rs extends Record<RouteRecordName, RoutiderRouteRecord>> = {
    [K in keyof Rs]: ExtractQueries<Rs[K]>;
}[keyof Rs];
/**
 * Get Typed `RouteLocationNormalizedLoaded` from Route
 */
export declare type RoutiderLocationOfNames<Routes extends RoutiderRoutes, N extends RouteNames<Routes> | RouteNames<Routes>[]> = RoutiderLocation<IntersectionParamsOfRoutes<RoutesOfNames<Routes, N>>, UnionParamsOfRoutes<RoutesOfNames<Routes, N>>, UnionQueriesOfRoutes<RoutesOfNames<Routes, N>>, EntityOrArrayToUnion<N>>;
export {};
